#!/bin/sh
#
# Adaptat de l'orginal disponible a:
# http://wiki.libvirt.org/page/Networking#Forwarding_Incoming_Connections
#

DEBUG="/etc/libvirt/hooks/qemu: $0 $*"
logger "$DEBUG"
echo "$DEBUG"

Guest_name="${1}"
VIRSH_CMD="${2}"
PUBLIC_IP="{{ ansible_facts['default_ipv4']['address'] }}"

# afegir linies al final amb els redireccionaments.
redirecciona() {
    Host_port="${1}"
    Guest_ipaddr="${2}"
    Guest_port="${3}"

    if [ "$VIRSH_CMD" = "stopped" -o "$VIRSH_CMD" = "reconnect" ]; then
        iptables -t nat -D PREROUTING -d ${PUBLIC_IP} -p tcp --dport ${Host_port} -j DNAT \
                 --to ${Guest_ipaddr}:${Guest_port}
        iptables -D FORWARD -d ${Guest_ipaddr}/32 -p tcp -m state --state NEW \
                 -m tcp --dport ${Guest_port} -j ACCEPT
    fi
    if [ "$VIRSH_CMD" = "start" -o "$VIRSH_CMD" = "reconnect" ]; then
        iptables -t nat -A PREROUTING -d ${PUBLIC_IP} -p tcp --dport ${Host_port} -j DNAT \
                 --to ${Guest_ipaddr}:${Guest_port}
        iptables -I FORWARD -d ${Guest_ipaddr}/32 -p tcp -m state --state NEW \
                 -m tcp --dport ${Guest_port} -j ACCEPT
    fi
}

# afegir el case de cada equip, i a dins una linia per cada servei.
#     redirecciona  <host_port> <guest_address> <guest_port>
case "$Guest_name" in
    murdock)
	redirecciona 80  192.168.122.233 80
	redirecciona 443 192.168.122.233 443
	;;

    nelson)
	redirecciona {{ hostvars['nelson.caliu.cat']['ssh_port'] }} 192.168.122.241 {{ hostvars['nelson.caliu.cat']['ssh_port'] }}
	;;

    perens)
	redirecciona {{ hostvars['perens.caliu.cat']['ssh_port'] }} 192.168.122.239 {{ hostvars['perens.caliu.cat']['ssh_port'] }}
	;;

esac
